After the last updates USB printers connected via HPLIP (or libusb in general) stopped working

Bug #595650 reported by andschuster on 2010-06-17
204
This bug affects 29 people
Affects Status Importance Assigned to Milestone
HPLIP
Undecided
Unassigned
hplip (Ubuntu)
Medium
Unassigned
Lucid
Undecided
Unassigned
Maverick
Medium
Unassigned
libusb (Ubuntu)
Critical
Unassigned
Lucid
Critical
Martin Pitt
Maverick
Critical
Unassigned
linux (Ubuntu)
Medium
Unassigned
Lucid
Undecided
Unassigned
Maverick
Medium
Unassigned

Bug Description

Binary package hint: cups

Hallo,

after the last updates my laserjet 1300 stopped working. cups still sees the printer, but if I try to print a test page I get a communication error. In /var/syslog I found:

hp[8640] prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/hp_LaserJet_1300?serial=00CNBD032941; will retry in 30 seconds...

Trying to print to this printer using windows (dual boot system) works fine.

More information:

lsmod|grep usb
usblp 10481 0
usbhid 36110 0
hid 67032 1 usbhid
usb_storage 39425 0

tail -f /var/log/messages after unplugging the printer:

Jun 17 21:09:14 darkstar kernel: [ 4260.312038] usb 5-1: USB disconnect, address 13
Jun 17 21:09:14 darkstar kernel: [ 4260.312209] usblp0: removed
Jun 17 21:09:14 darkstar udev-configure-printer: Disabled printer ipp://localhost:631/printers/hp-LaserJet-1300 as the corresponding device was unplugged or turned off
Jun 17 21:09:14 darkstar udev-configure-printer: Disabled printer ipp://localhost:631/printers/hp-LaserJet-1300 as the corresponding device was unplugged or turned off

And after plugging in the printer again:

Jun 17 21:12:12 darkstar kernel: [ 4437.756299] usb 2-6.1: new full speed USB device using ehci_hcd and address 21
Jun 17 21:12:12 darkstar kernel: [ 4437.850779] usb 2-6.1: configuration #1 chosen from 1 choice
Jun 17 21:12:12 darkstar kernel: [ 4437.852201] usblp0: USB Bidirectional printer dev 21 if 0 alt 1 proto 2 vid 0x03F0 pid 0x1017
Jun 17 21:12:13 darkstar kernel: [ 4439.199530] usb 2-6.1: usbfs: interface 0 claimed by usblp while 'usb' sets config #1
Jun 17 21:12:15 darkstar udev-configure-printer: Re-enabled printer ipp://localhost:631/printers/hp-LaserJet-1300

And then:

lpinfo -v
direct scsi
network lpd
network ipp
network socket
network beh
serial serial:/dev/ttyS0?baud=115200
serial serial:/dev/ttyS1?baud=115200
network http
network smb
direct parallel:/dev/lp0
direct usb://HP/LaserJet%201300
direct hp:/usb/hp_LaserJet_1300?serial=00CNBD032941
direct hpfax

lsb_release -rd
Description: Ubuntu 10.04 LTS
Release: 10.04

pt-cache policy cups
cups:
  Installiert: 1.4.3-1ubuntu1
  Kandidat: 1.4.3-1ubuntu1
  Versions-Tabelle:
 *** 1.4.3-1ubuntu1 0
        500 http://de.archive.ubuntu.com/ubuntu/ lucid-updates/main Packages
        100 /var/lib/dpkg/status
     1.4.3-1 0
        500 http://de.archive.ubuntu.com/ubuntu/ lucid/main Packages

andschuster (andreas-schuster2) wrote :

Another observation: If I print with "cat datei > /dev/usb/lp0" the printer starts printing.

andschuster (andreas-schuster2) wrote :

After uninstalling hplip and hplip-gui printing starts working again!

Till Kamppeter (till-kamppeter) wrote :

Can you install hplip and hplip-gui again and create a new print queue, with another name. Can you print through this print queue?

Changed in cups (Ubuntu):
status: New → Incomplete
andschuster (andreas-schuster2) wrote :

Till,
I reinstalled hplip and hplip-gui again and created an new queue with a different name, but the errors remain and printing didn't work. I have to uninstall the packages and then printing started working again.

Wim Cools (wim-cools) wrote :

I have the same problem with printer HP psc-750.

Jun 19 16:26:11 dikkepels kernel: [ 1530.320026] usb 6-2: new full speed USB device using uhci_hcd and address 5
Jun 19 16:26:11 dikkepels kernel: [ 1530.512935] usb 6-2: configuration #1 chosen from 1 choice
Jun 19 16:26:11 dikkepels udev-configure-printer: add /devices/pci0000:00/0000:00:1d.1/usb6/6-2/6-2:1.0
Jun 19 16:26:11 dikkepels udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.1/usb6/6-2
Jun 19 16:26:11 dikkepels udev-configure-printer: Device vendor/product is 03F0:1411
Jun 19 16:26:11 dikkepels udev-configure-printer: failed to claim interface
Jun 19 16:26:11 dikkepels udev-configure-printer: invalid or missing IEEE 1284 Device ID
Jun 19 16:26:11 dikkepels udev-configure-printer: add /devices/pci0000:00/0000:00:1d.1/usb6/6-2/6-2:1.0/usb/lp0
Jun 19 16:26:11 dikkepels udev-configure-printer: parent devpath is /devices/pci0000:00/0000:00:1d.1/usb6/6-2
Jun 19 16:26:11 dikkepels udev-configure-printer: MFG:Hewlett-Packard MDL:PSC 750 SERN:HU1BRCT2FKWB serial:HU1BRCT2FKWB
Jun 19 16:26:11 dikkepels kernel: [ 1530.520892] usblp0: USB Bidirectional printer dev 5 if 0 alt 1 proto 2 vid 0x03F0 pid 0x1411
Jun 19 16:26:12 dikkepels kernel: [ 1531.541835] usb 6-2: usbfs: interface 0 claimed by usblp while 'usb' sets config #1
Jun 19 16:26:12 dikkepels hp[2923]: io/hpmud/pp.c 627: unable to read device-id ret=-1
Jun 19 16:26:12 dikkepels python: io/hpmud/pp.c 627: unable to read device-id ret=-1
Jun 19 16:26:14 dikkepels udev-configure-printer: SERN fields match
Jun 19 16:26:14 dikkepels udev-configure-printer: URI match: usb://HP/PSC%20750?serial=HU1BRCT2FKWB
Jun 19 16:26:14 dikkepels udev-configure-printer: SERN fields match
Jun 19 16:26:14 dikkepels udev-configure-printer: URI match: hp:/usb/PSC_750?serial=HU1BRCT2FKWB
Jun 19 16:26:14 dikkepels udev-configure-printer: Consider also queues with "/usb/lp0" or "/usblp0" in their URIs as matching
Jun 19 16:26:14 dikkepels udev-configure-printer: URI of print queue: hp:/usb/PSC_750?serial=HU1BRCT2FKWB, normalized: psc 750 serial hu1brct2fkwb
Jun 19 16:26:14 dikkepels udev-configure-printer: URI of detected printer: usb://HP/PSC%20750?serial=HU1BRCT2FKWB, normalized: psc 750 serial hu1brct2fkwb
Jun 19 16:26:14 dikkepels udev-configure-printer: Queue ipp://localhost:631/printers/PSC-750 has matching device URI
Jun 19 16:26:14 dikkepels udev-configure-printer: Re-enabled printer ipp://localhost:631/printers/PSC-750
Jun 19 16:26:14 dikkepels udev-configure-printer: URI of detected printer: hp:/usb/PSC_750?serial=HU1BRCT2FKWB, normalized: psc 750 serial hu1brct2fkwb
Jun 19 16:26:14 dikkepels udev-configure-printer: Queue ipp://localhost:631/printers/PSC-750 has matching device URI
Jun 19 16:26:14 dikkepels udev-configure-printer: Re-enabled printer ipp://localhost:631/printers/PSC-750
Jun 19 16:26:24 dikkepels hp[2748]: prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/PSC_750?serial=HU1BRCT2FKWB; will retry in 30 seconds...
Jun 19 16:27:43 dikkepels hp[2748]: last message repeated 2 times

Changed in cups (Ubuntu):
status: Incomplete → Confirmed
Till Kamppeter (till-kamppeter) wrote :

Looks like an upstream bug of HPLIP, added upstream task.

affects: cups (Ubuntu) → hplip (Ubuntu)
Changed in hplip:
status: New → Confirmed
Wim Cools (wim-cools) wrote :

I have installed hplip 3.10.5 but I have the same problem.
prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/PSC_750?serial=HU1BRCT2FKWB

Till Kamppeter (till-kamppeter) wrote :

Seems that the HPLIP backend has lost compatibility to some devices. Can someone at HP check? Thanks.

Procion (klebed) wrote :

Confirm... HP LJ 1015 don't work after updates.

And no older version of hplip in repo, so i can't downgrade to workable configuration. It's very sad. =(
I think there must be at least one older version available to avoid such bugs in LTS.

Wolfgang Glas (wglas) wrote :

I'm affected her, too, using Hp LaserJet 1010 with my laptop.

I strongly doubt, that hplip is the culprit here, because there's no hplip package in lucid-updates or lucid-proposed.
I currently have hplip-3.10.2-2ubuntu2 installed, which date to April, 12th, 2010.

I think the bug must have been introduced by cups-1.4.3-1ubuntu1.2, which has been released on June, 18th, 2010.

  Best regards,

   Wolfgang

So I believe that there will be a lot of "normal users" (such not having any knowledge about launchpad, ...) of 10.04 LTS who have that problem, because ubuntu uses the hp-backend by default if it finds a printer made by HP (is this correct?) and will stop printing. A very problematic situation for a long term edition!

Wim Cools (wim-cools) wrote :
Procion (klebed) wrote :

Maybe "Time machine(MacOS X)"-like feature will be very useful in that case. Just to rollback some of updates. Update-manager should do it automaticaly, before installing each update, for example.

Wolfgang Glas, the security update in CUPS is most probably not the culprit, as the hardware access is not done via CUPS but through the HPLIP CUPS backend and the backend communicates directly with the kernel.

Possible causes for the bug:

1. A kernel update broke the USB stack. Did you get asked for rebooting the system after one of your last updates? Did you actually reboot?

2. Problem with AppArmor. In this case proceed as described under "AppArmor Protection of the printing system" on https://wiki.ubuntu.com/DebuggingPrintingProblems

andschuster, most of HP's printers still work on Lucid, otherwise we had a lot more bug reports. I have also many HP printers and I did not see any problems with them. But in general this should get fixed for the LTS.

Wolfgang Glas (wglas) wrote :

FYI, 'sudo aa-complain cupsd' doesn't change anything, so a kernel update might be the cause. I have installed two kernel upates since the release of lucid, 2.6.32-22 (lucid-updates) and 2.6.32-23 (lucid-proposed). The bug occurs with bot updates.

andschuster, could you try to reboot to 2.6.23-21 and reproduce the bug there?

It look like "/usr/lib/cups/backend/hp" backend is failed to open device and exit with status 21.
Up to i know "SELinux" is also in disable state in ubuntu.
Printing has been working before upgrade and also with different version of Ubuntu. I guess "hplip" package has no changes with this upgrade.

Workaround: Adding printer from CUPS web interface. http://localhost:631. So, CUPS will use "usb" as backend for communication.
Once if we get "/usr/lib/cups/backend/hp". we need to restart the machine.
/usr/lib/cups/backend/hp uses libusb API calls for USB communication with printer. "/usr/lib/cups/backend/hp" code is same/common for all the HP printers (device independent), .

Can any one run "hp-makeuri" and attach the output.

Wim Cools,
hp-check log showing that your system is using "hpcups" filter and using "hpijs" ppd for printing.
Can you please remove printer queue and re-add it.

It looks like some issues with 2.6.32-22 and 2.6.32-21 with USB. Not only with Printer USB.

I will try to reproduce and fix this issue.

Thanks for your support!
Naga Samrat Chowdary, Narla

Wim Cools (wim-cools) wrote :
Wim Cools (wim-cools) wrote :

I tried to add a printer from CUPS web interface. But find printer and add printer 'hangs' (web time-out).

With hp-setup I can add the printer, but the printer doesn't print.

Thanks for your help.

Wim Cools

After uninstalling hplip my printer ist recognized by kubuntu system tools and the system used the "usb" backend. As I already wrote printing works then again.

Procion (klebed) wrote :

Confirm #19

Uninstalling hplip and setting new uri - fixes printing ability.

Can everyone suffering this bug re-install HPLIP and try whether he can print using HPLIP when booting an older kernel? Please try different kernels and tell us which is the newest kernel with which printing still works.

Added a kernel task.

Changed in hplip (Ubuntu):
importance: Undecided → Medium
Changed in linux (Ubuntu):
importance: Undecided → Medium
status: New → Confirmed
Wim Cools (wim-cools) wrote :

- Try 1 remove hplip
When I remove hplip and reinstall my hp psc-750 printer I can print.
However I can't scan. (scanner not available)

- Try 2 older kernel
My oldest kernel available is 2.6.32-21-generic and my printer doesn't work with this kernel and I stil have the same problem with hplip. hp[2748]: prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/PSC_750?serial=HU1BRCT2FKWB;

This bug affects me too with a HP Laserjet 3330. If I try to print I get a message saying "Is printer connected?" and in the queue "Not connected" can be read. If I connect and disconnect the printer to the USB port I get the following through dmesg:

[ 981.008045] usb 5-2: USB disconnect, address 3
[ 981.008235] usblp0: removed
[ 983.732012] usb 5-2: new full speed USB device using uhci_hcd and address 4
[ 983.918993] usb 5-2: configuration #1 chosen from 1 choice
[ 983.925930] usblp0: USB Bidirectional printer dev 4 if 0 alt 1 proto 2 vid 0x03F0 pid 0x0917
[ 985.321540] usb 5-2: usbfs: interface 0 claimed by usblp while 'usb' sets config #1

I tried to collect information in the attached file with "apport-bug -f --save info.txt linux".

The workaround suggested in #16 works for me too.

As per "hp-makeuri" as demanded in #16:

lsusb:

Bus 005 Device 004: ID 03f0:0917 Hewlett-Packard LaserJet 3330
Bus 005 Device 002: ID 0830:0061 Palm, Inc. Lifedrive / Treo 650/680 / Tunsten E2/T5/TX / Zire 21/31/72 / Z22
Bus 005 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 004 Device 003: ID 413c:2003 Dell Computer Corp. Keyboard
Bus 004 Device 002: ID 045e:0040 Microsoft Corp. Wheel Mouse Optical
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 001 Device 010: ID 059f:0651 LaCie, Ltd
Bus 001 Device 009: ID 046d:08da Logitech, Inc. QuickCam Messanger
Bus 001 Device 004: ID 04b4:6830 Cypress Semiconductor Corp. CY7C68300A EZ-USB AT2 USB 2.0 to ATA/ATAPI
Bus 001 Device 003: ID 05e3:0606 Genesys Logic, Inc. USB 2.0 Hub / D-Link DUB-H4 USB 2.0 Hub
Bus 001 Device 002: ID 05e3:0605 Genesys Logic, Inc. USB 2.0 Hub [ednet]
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub

hp-makeuri 03f0:0917:

HP Linux Imaging and Printing System (ver. 3.10.2)
Device URI Creation Utility ver. 5.0

Copyright (c) 2001-9 Hewlett-Packard Development Company, LP
This software comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to distribute it
under certain conditions. See COPYING file for more details.

error: Device not found

Walter Garcia-Fontes, you are using the wrong syntax for hp-makeuri. The right way is

hp-makeuri <bus>:<device>, so in your case

hp-makeuri 005:004

Note that bus and device change when you turn off the printer or disconnect it. So run "lsusb" again to get updated bus and device numbers. Important is also that they must enter them with three digits, padded with zeros.

If the command shown above fails, try it also with "sudo", like:

sudo hp-makeuri 005:004

Walter Garcia-Fontes, can you also run

ls -l /dev/usb/lp* /dev/bus/usb/*/*
sudo usb_printer_id /dev/usb/lp0
sudo usb_printer_id /dev/usb/lp1
lpinfo -v
/usr/lib/cups/backend/hp
/usr/lib/cups/backend/usb
lsmod | grep usb

Jaak Ristioja (jotik) wrote :

I just ran into a similar problem today with libusb-0.1-4=2:0.1.12-14ubuntu0.1. The printer just stopped printing after upgrading from libusb-0.1-4=2:0.1.12-14 and rebooting. Downgrading to libusb-0.1-4=2:0.1.12-14 fixed this issue after reboot. Is this the same bug?

Wolfgang Glas (wglas) wrote :

Jaak, you got the culprit, ThX very much ;-)

 I have two laptops, one with lucid-proposed activated and one without lucid-proposed. The one without lucid.proposed prints on my LaserJet 1010 just as expeccted, while the one with ubuntu-proposed stopped printing around mid-june.

This the changelog entry, which most likely introduced the regression:

libusb (2:0.1.12-14ubuntu0.1) lucid-proposed; urgency=low

  * Add 07_altsetting_alloc.patch: Fix crash due to uninitialized memory.
    Thanks to Eric Miao for debugging this and the patch! (LP: #427805)

 -- Martin Pitt <email address hidden> Tue, 15 Jun 2010 09:26:07 +0200

Everyone who has this problem, please try downgrading libusb to 2:0.1.12-14 and check whether printing returns to work.

Changed in libusb (Ubuntu):
status: New → Confirmed
status: Confirmed → Incomplete

Setting to "Confirmed" as, including the last comments in bug 427805, several users have proven that the last libusb update is the culprit.

Closing HPLIP and kernel tasks ...

The fix for this bug should also be released as SRU for all releases where this last libusb bug fix was releaseed as SRU.

Changed in libusb (Ubuntu):
importance: Undecided → High
status: Incomplete → Confirmed
Changed in hplip:
status: Confirmed → Invalid
Changed in hplip (Ubuntu Lucid):
status: New → Invalid
Changed in hplip (Ubuntu Maverick):
status: Confirmed → Invalid
Changed in libusb (Ubuntu Lucid):
status: New → Invalid
status: Invalid → Confirmed
importance: Undecided → High
Changed in linux (Ubuntu Lucid):
status: New → Invalid
Changed in linux (Ubuntu Maverick):
status: Confirmed → Invalid

Jaak, thank you very much. I have updated the bug report now and also proposed it for a SRU in Lucid.

Hi!

I have the same problem with my HP color Laserjet 2550L.

Im not a linux pro... but I notised one thing... The HP 2550L printer works in windows inside virtual box.
maby helps to find the bug...

A Brother-DCP-9042CDN works (installed after the bug appeared)

thanks dor all good work!

/Johan

floid (jkanowitz) wrote :

@Johan Stenlund, and anyone else stymied, the incantation you are looking for is:

aptitude forbid-version libusb-0.1-4=2:0.1.12-14ubuntu0

(Or use apt-get's same 'downgrade' feature directly.)

It would also help [me] to remember that /var/log/apt/history.log exists when trying to recover from a bad update. (Has anyone thought of having update-manager create and install local "meta-package" .debs instead of installing directly for ease of backing out after a SNAFU? Does apt even support that? Belongs on Brainstorm, not in this bug, but I'll type it here while it's fresh...)

Nice detective work on this one!

fedsed (fedor-s) wrote :

At me such error too is observed. The exit has found such:
lpinfo -v
direct usb://HP/LaserJet%201300
direct hp:/usb/hp_LaserJet_1300?serial=00CNBD571707

I substitute variant usb://HP/LaserJet%201300 and the printer prints

summary: - after the last updates printer stopped working
+ After the last updates HP printer stopped working

I use a HP Laserjet 1010 and cannot print anymore since the update done on 3. July 2010.

What does not work
- printing in general. Error message: "maybe not connected"
- test print initiated from notebook

What works:
- printer is recognized automatically
- test print initiated from button on printer itself
- printing with same hardware/cabling but run with old live-CD

I hope a future update will cure this because the hints included above are not implementable for me as a normal user. As much as I can copy&paste into terminal I have no clue what to do if step details are missing (e.g. #36: how to "substitute variant"). Nevertheless THANKS A LOT to all supporting Ubuntu. This is great!

marmuta (marmuta) wrote :

Had the same symptoms and downgrading to libusb-0.1.4 fixed it here too (HP 3330 MFP).

In Synaptic select package libusb-0.1.4, then the menu item Package->Force Version, choose "2:0.1.12-14 (lucid)" and apply the changes. After that reconnecting the printer was enough to make both scanning and printing work again.

Thanks Jaak for tracking this down!

Cesare Mastroianni (cece) wrote :

Thanks to Till Kamppeter, I came into the present bug report coming from my bug report #597612. I was not able to print since yesterday (after the automatic upgrade to libusb 0.1-4 ... Today I downgraded to 0.1.12-14ubuntu0.1 and the printer started to print again.

Many thanks to Mr. Till and to You all.

Ciao.
CM

locutus (locutus-gmx) wrote :

#38 solved the problem for me. Thank you marmuta for easy implementable work-around.

Wim Cools (wim-cools) wrote :

I can scan and print again with my HP PSC-750. :-)
When downgrading libusb I saw that libgphoto2-2-dev, libsane-dev and libusb will be removed.
I don't know what the impact is.

Thank you all for the support.

Wim

Daedalus Fly (daedalus-fly) wrote :

Downgrading to 0.1.12-14ubuntu0.1 worked for my HP 1012 Laser Jet. Thank you. As a newb, this would have been a deal-breaker for me and Ubuntu.

floid (jkanowitz) wrote :

Tangentially related to this: If gscan2pdf suddenly refuses to show any "device-dependent options" (such as DPI or color vs. grayscale mode) for the scanner on your multifunction [perhaps due to this bug or side-effects of attempts to correct it], use the "Clear device-dependent options cache" feature in gscan2pdf's Edit->Preferences menu.

This was not terribly obvious, since it takes some exploring to discover there's a 'cache' - it's on by default, since it cuts out some of the wait in normal usage. In my case it cached some sort of corrupt result while unable to communicate with the scanner, and misled me into thinking that the scanimage backend must have remained broken.

[Moral of this story: When in doubt, remember to rename .gscan2pdf aside, or test under a fresh user account.]

I guess I'll open a bug on gscan2pdf to suggest offering a "Refresh cache?" right in the Scan->Options dialog when the cached configuration is corrupt.

Changed in libusb (Ubuntu Lucid):
importance: High → Critical
Changed in libusb (Ubuntu Maverick):
importance: High → Critical
Changed in libusb (Ubuntu Lucid):
milestone: none → lucid-updates
stephisa41 (stefan41) wrote :

Hi everybody. The downgrading to 0.1.12-14ubuntu0.1 worked also for my PSC750. I was about to leave Ubuntu when I saw this solution. Many thanks for the community for the help provided.

Wim Cools, libgphoto2-2-dev and libsane-dev are packages only needed to compile programs which use libgphoto2 or libsane resp. If you need them, simply install them again.

floid, please report a bug on gscan2pdf, as what you describe is a design flaw of gscan2pdf.

floid (jkanowitz) wrote :

@Till Kamppeter:
https://bugs.launchpad.net/ubuntu/+source/gscan2pdf/+bug/602560

It takes "this bug" to trigger that behavior in gscan2pdf, and without realizing the cause it made scanning "look" broken after backing out the bad libusb. So worth documenting here while reporting there. :)

Meadow (meadow-sunrise) wrote :

Now it is clear that libusb 0.1.12-14ubuntu0.1 is faulty, is it possible to stop to advertise it in the update system ?
The more it stays as a recommended update the higher it will have impact.

Printing is an essential feature - so fixing this bug or stopping the distribution of the faulty package is very important!

andschuster, therefore I have set the bug importance to "Critical" for both Maverick and Lucid.

vDopey (vamegh) wrote :

Hi Just to raise priority of this, there is also forum postings about this here:

http://ubuntu-ky.ubuntuforums.org/showthread.php?t=1524438&page=2 , I had the same problem and tried a myriad of different things none of which worked, but downgrading libusb obviously does, as below:

sudo apt-get install libusb-0.1-4=2:0.1.12-14

I had several different errors associated around this, initially it would fail to register the printer with an error about

usbfs: interface 0 claimed by usblp while 'usb' sets config #1

Following instructions from here:

http://<email address hidden>/2010-05/67366/(Bug-420015)-Re-usblp-Kernel-module-needs-to-be-removed-and-dev-bus-usb---made-accessible-for-USB-printers-to-work-with-CUP.html

The error was changed to the following:

hp[5252]: prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/hp_LaserJet_1010?serial=(removed); will retry in 30 seconds

The problem is definitely with libusb as downgrading solved my issues as well.

Martin Pitt (pitti) on 2010-07-12
tags: added: regression-update
Martin Pitt (pitti) wrote :

Indeed the previous libusb patch would overwrite previous altsettings, sorry that I didn't spot this. When I reviewed this original SRU, I just looked at the realloc()/memset() sequence, which seems fine at the first sight. realloc() by no way guarantees you that the reallocated pointer is still the same as the original one, so you would have to copy the previous contents if they are different. But the code does not do that and blindly assumes that the pointer remains constant.

However, Pawel's patch should avoid this regression and does not scribble over the previously written altsettings, so I'll sponsor this into lucid. This would still fail in some cases, but so it would in the final lucid version, so let's fix that regression first.

Changed in libusb (Ubuntu Lucid):
assignee: nobody → Martin Pitt (pitti)
status: Confirmed → In Progress
Martin Pitt (pitti) wrote :

Updated libusb uploaded to lucid-proposed, awaiting SRU team review.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libusb - 2:0.1.12-15ubuntu2

---------------
libusb (2:0.1.12-15ubuntu2) maverick; urgency=low

  * 07_altsetting_alloc.patch: Update patch to only clear the current
    altsetting record in the loop, not overwrite previously written ones.
    Thanks to Pawel Kot! (LP: #427805, #595650)
 -- Martin Pitt <email address hidden> Mon, 12 Jul 2010 08:20:34 +0200

Changed in libusb (Ubuntu Maverick):
status: Confirmed → Fix Released
Cesare Mastroianni (cece) wrote :

Thank You so far. However ...

In my comment #39 I wrote that everything was ok after downgrading libusb. This is not fully correct.

After I detected the bug HP printer won't work at all. After downgrading, HP printer start printing again but today I discovered it is not able to print doubleface paper anymore (two side printing) when printing PDF files from the Document Viewer.

The HP printer works greatly from OpenOffice for instance, printing doubleface paper smoothly, but it fails to print doubleface from PDF files.

Before the bug appeared I had no problem with doubleface PDF documents.

I can't understand if there is some relationship with the libusb downgrade. I'm trying to investigate it furthermore. Please, could You test Your HP printer with PDF two side printing?

Ciao. Grazie.
CM

Accepted libusb into lucid-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in libusb (Ubuntu Lucid):
status: In Progress → Fix Committed
tags: added: verification-needed

The package from lucid-proposed works for me.

tags: added: verification-done
removed: verification-needed

The package from lucid-proposed is working well.

Cesare Mastroianni (cece) wrote :

Sorry to bother You, but I can't download the proposed package. I have:

$ tail -1 /etc/apt/sources.list
deb http://archive.ubuntu.com/ubuntu/ lucid-proposed restricted main multiverse universe

$ sudo apt-get update
[...]
Trovato http://ddebs.ubuntu.com lucid-proposed/restricted Packages
Trovato http://ddebs.ubuntu.com lucid-proposed/universe Packages
Trovato http://ddebs.ubuntu.com lucid-proposed/multiverse Packages
[...]

$ sudo aptitude install libusb/lucid-proposed
[...]
Impossibile trovare il pacchetto «libusb». Ad ogni modo, i seguenti
pacchetti hanno un nome che contiene «libusb»:
  libusbip0 libusb-1.0-0-udeb-dbgsym libusb-1.0-0-dbgsym
  libusb-0.1-4-dbgsym libusbprog0 libusbip0-dbgsym libusb-ruby1.9.1
  libusb-1.0-0-dev libusb-ruby1.8-dbgsym libusb++-0.1-4c2
  libusbmuxd1-dbgsym libusb-ruby1.8 libusb-ruby libusb-dev libusbprog-dev
  libusbmuxd-dev libusb-ruby1.9.1-dbgsym libusb-0.1-4
  libusb++-0.1-4c2-dbgsym libusbmuxd1 libusbprog0-dbgsym libusb++-dev
  libusbip-dev libusb-1.0-0 libusbmuxd1-dbg
[...]

Where is my error?

Ciao
CM

Gavin Munday (gmunday-shaw) wrote :

HP LaserJet 3030 would not print. This problem affected all three computers after upgrading to Ubuntu 10.04. Status message: "Printer 'hp-LaserJet-3030' may not be connected" I downloaded the package libusb-0.1-4 from lucid-proposed and the problem was solved. I am delighted to have this fixed. Thank you!

floid (jkanowitz) wrote :

@Cesare Mastroianni:

Try specifying "libusb-0.1-4" rather than "libusb".

Upstream http://www.libusb.org/ gives some background for that naming convention [it should be possible to install the "legacy" libusb-0.1-4 and "stable" libusb-1.0-0 concurrently if you ever need to], though why the "-4" became codified is beyond me at the moment. :)

Cesare Mastroianni (cece) wrote :

FLOID: Ooopppsss!!! Sorry for my stupid question at comment #59 and thank You for Your reply.

ok - libusb-0.1-4 PROPOSED worked for me as well.

On comment #55 I described a problem related to duplex printing (dual side printing - an hardware enabled feature of many HP printers) ... thank You DANIEL for Your private answer.

After some tests with the new PROPOSED libusb, I suspect that the problem is not related to the usb driver, many rather it could be related to the "printer language" interface (cups or hplip or something similar). Therefore You could consider void my comment #55 ... I will focus on this later and maybe I will report a separate bug, if this will be the case.

Grazie.
CM

Cesare Mastroianni (cece) wrote :

Sorry to bother You again ... after some tests, I noticed that all the failed two-sided printing generated always the same error. Please, see the latest event here below:

/var/log/daemon.log:
Jul 14 08:44:19 uffcom2 hp[9036]: io/hpmud/musb.c 1403: unable to write data hp:/usb/hp_LaserJet_1320_series?serial=00CNRW66G0LB: 45 second io timeout

When this log line appears, then the printer "hang" for an indefinite time, having the "receiving data" flashing forever. Any further attempt to print fails, because the new docs are queued after the "hanging" one. If I try to "delete" or "abandon" the print from the queue window, the printer still stays into this "hanging" status. The only way I found so far to restore the printing is to turn the printer off and turn it on again.

Would You please tell me if this is somehow related to libusb or if I should search for the problem elsewhere?

Thank You in advance.
Ciao
CM

Cesare Mastroianni, it can be that your printer is running out of memory. Can you try to use the printer with a PCL driver (hpcups, hpijs, pxlmono, ...)?

floid (jkanowitz) wrote :

@Cesare Mastroianni:

Regarding the double-sided printing trouble, have you confirmed you are using the same version of hplip as before the update that gave you the troublesome libusb (check /var/log/apt/history.log for what else was installed in the update that gave you libusb-0.1-4 0.1.12-14ubuntu0.1)? If it's a regression compared to an older hplip, you want to file a bug against it at https://bugs.launchpad.net/ubuntu/+source/hplip/ .

0.1.12-14 was the libusb-0.1-4 released with lucid [the only version available until now], and you observed it broken after downgrading back to that, so it smells like hplip to me.

@world:

I didn't see the ".1" in the original versioning, so my advice to use:
aptitude forbid-version libusb-0.1-4=2:0.1.12-14ubuntu0
will exclude the patched patch too, oops! It should have read:
aptitude forbid-version libusb-0.1-4=2:0.1.12-14ubuntu0.1

If you don't have the lucid-proposed repo enabled, it looks like you can undo this overbroad 'forbid-version' by running:
aptitude install libusb-0.1-4=2:0.1.12-14ubuntu0.2
and saying 'No' to its intention to install libusb-0.1-4=2:0.1.12-14ubuntu0.1 when ...ubuntu0.2 is not available.
Then you can run the correct:
aptitude forbid-version libusb-0.1-4=2:0.1.12-14ubuntu0.1
to only exclude the bad version, and accept ...ubuntu0.2 when it's approved.

Cesare Mastroianni (cece) wrote :

Many many thanks to both Floid and Till.

It seems that I have problems with hplip and/or cups ... so I move this discussion elsewhere.

The libusb driver works.

Ciao
CM

Michael Luthardt (michalu) wrote :

Same problem here for HP Business Inkjet 1200.
Ubuntu 10.04 amd64. After the latest updates the printer stopped working. Installing the latest hplip from HP - no help. Thanks to this track, installing libusb-0.1-4 (2:0.1.12-14ubuntu02) from proposed via Synaptic solved this issue for me.
The version numbering is indeed strange, because libusb-1.0-0 (2:1.0.6-1) is installed by lucid.

floid (jkanowitz) wrote :

It's fairly common to have the "legacy" or "stable" branch of a library installed concurrently with its current or development branch. This generally indicates that the interface [is assumed to have] changed between libusb-0.1 and libusb-1.0 such that consumers of the former can't just relink against the latter.

Juggling the version numbers without introducing human error in referencing them is another matter!

Joel Webb (joel-propbot) wrote :

Using Ubuntu Lucid with HP Printer 3020
Tried compile from stable branch from HP.

date > /dev/usb/lp printer test worked fine for me.

Printer and Scanner worked on Hardy perfectly.

Tobias (info-linopus) wrote :

Installation of libusb from lucid proposed solved the problem of printers suddenly unavailable after the last update for me. Thanks for the fix.

Linuxexperte (andrea-koeth) wrote :

checked this for my HP-printer (Deskjet F4280 all-in-one) and this printer works fine for me in Maverick Meerkat.
So I am not ffected by this bug. I ust had update a few minutes ago and I cannot confirm this bug for me.

Greetings
Linuxexperte

Joel Webb (joel-propbot) wrote :

libusb fix worked for me also. thanks Michael and floid

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libusb - 2:0.1.12-14ubuntu0.2

---------------
libusb (2:0.1.12-14ubuntu0.2) lucid-proposed; urgency=low

  * 07_altsetting_alloc.patch: Update patch to only clear the current
    altsetting record in the loop, not overwrite previously written ones.
    Thanks to Pawel Kot! (LP: #427805, #595650)
 -- Martin Pitt <email address hidden> Mon, 12 Jul 2010 08:26:54 +0200

Changed in libusb (Ubuntu Lucid):
status: Fix Committed → Fix Released

The problem described here can also occur for non-HP USB printers, in general when the printer is accessed via libusb. This does not only happen when the printer is accessed through the "hp" CUPS backend of HPLIP but also via the "usb" backend of CUPS when the "usblp" kernel module is blacklisted or via manufacturer-supplied libusb-based CUPS backends. In any case do a full system-update to get the updated libusb.

summary: - After the last updates HP printer stopped working
+ After the last updates USB printers connected via HPLIP (or libusb in
+ general) stopped working
Download full text (4.3 KiB)

This last message fixed the problem.
After a complete system update and reboot HP printer works from boot up.
Thanks to all.
I write assembler code for intel, and c, c++.
If there are very small jobs I would gladly offer to code.
Would you point me in the right direction?
John

On Jul 19, 2010, at 4:38 AM, Till Kamppeter wrote:

> The problem described here can also occur for non-HP USB printers, in
> general when the printer is accessed via libusb. This does not only
> happen when the printer is accessed through the "hp" CUPS backend of
> HPLIP but also via the "usb" backend of CUPS when the "usblp" kernel
> module is blacklisted or via manufacturer-supplied libusb-based CUPS
> backends. In any case do a full system-update to get the updated libusb.
>
>
> ** Summary changed:
>
> - After the last updates HP printer stopped working
> + After the last updates USB printers connected via HPLIP (or libusb in general) stopped working
>
> --
> After the last updates USB printers connected via HPLIP (or libusb in general) stopped working
> https://bugs.launchpad.net/bugs/595650
> You received this bug notification because you are a direct subscriber
> of a duplicate bug (602087).
>
> Status in HP Linux Imaging and Printing: Invalid
> Status in “hplip” package in Ubuntu: Invalid
> Status in “libusb” package in Ubuntu: Fix Released
> Status in “linux” package in Ubuntu: Invalid
> Status in “hplip” source package in Lucid: Invalid
> Status in “libusb” source package in Lucid: Fix Released
> Status in “linux” source package in Lucid: Invalid
> Status in “hplip” source package in Maverick: Invalid
> Status in “libusb” source package in Maverick: Fix Released
> Status in “linux” source package in Maverick: Invalid
>
> Bug description:
> Binary package hint: cups
>
> Hallo,
>
> after the last updates my laserjet 1300 stopped working. cups still sees the printer, but if I try to print a test page I get a communication error. In /var/syslog I found:
>
> hp[8640] prnt/backend/hp.c 752: INFO: open device failed stat=21: hp:/usb/hp_LaserJet_1300?serial=00CNBD032941; will retry in 30 seconds...
>
> Trying to print to this printer using windows (dual boot system) works fine.
>
> More information:
>
> lsmod|grep usb
> usblp 10481 0
> usbhid 36110 0
> hid 67032 1 usbhid
> usb_storage 39425 0
>
> tail -f /var/log/messages after unplugging the printer:
>
> Jun 17 21:09:14 darkstar kernel: [ 4260.312038] usb 5-1: USB disconnect, address 13
> Jun 17 21:09:14 darkstar kernel: [ 4260.312209] usblp0: removed
> Jun 17 21:09:14 darkstar udev-configure-printer: Disabled printer ipp://localhost:631/printers/hp-LaserJet-1300 as the corresponding device was unplugged or turned off
> Jun 17 21:09:14 darkstar udev-configure-printer: Disabled printer ipp://localhost:631/printers/hp-LaserJet-1300 as the corresponding device was unplugged or turned off
>
> And after plugging in the printer again:
>
> Jun 17 21:12:12 darkstar kernel: [ 4437.756299] usb 2-6.1: new full speed USB device using ehci_hcd and address 21
> Jun 17 21:12:12 darkstar kernel: [ 4437.850779] usb 2-6.1: configuration #1 chosen ...

Read more...

Gerard (gteich04) wrote :

I have struggled getting my HP Laserjet 1018 back on line after ran ill advised update-manager session. Same results as other posts.
Installed 10.4 over the weekend from 9.10. No Change. Purged system of hplip. Followed Download instructions from HPlip website. This worked until the next shutdown/restart I checked which version of hplip is installed from the directory-- it it the 12-14.xxx.02 version.

Printer works with my Windows laptop and my eeepc.

So, I an not sure that this bug was in fact fixed with the 10.04 version. I can post more info if needed.

Ger

DLCBurggraaff (burdi) wrote :

Beste Gerard,
For as far as I am aware the problem this thread is about only occurred for 10.04 and 10.10, not 9.10. So whatever problem you had may or may not be the problem at hand.
Having said that, the resolution to the problem at hand was a fix to 10.04, not 10.04 by itself.
It is recommended top apply all fixes and follow instructions from Ubuntu. The chances that problems are resolved by these are much higher than the chances of introducing new problems.
Also, the chances that downloading fixes and following instructions from other websites is successful are much slimmer.
Groeten, Dick

Gerard (gteich04) wrote :

After reviewing this thread after trying other things, I looked carefully at my version of libusb, and I had not downgraded it to the correct version. Doing so and replugging my usb printer appears to have worked. I have uninstalled hplip, but maybe if there is now usb connectivity I can reinstall. Oh what a doosy!

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers